// CppVirtualMethodsOverride.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>

class A {
public:
    void m1() { std::cout << "A::m1" << std::endl; }
    virtual void m2() { std::cout << "A::m2" << std::endl; }
    virtual void m3() { std::cout << "A::m3" << std::endl; }
    virtual void m4() { std::cout << "A::m4" << std::endl; }
};

class B : public A {
public:
    void m1() { std::cout << "B::m1" << std::endl; }
    void m2() { std::cout << "B::m2" << std::endl; }
    virtual void m3() { std::cout << "B::m3" << std::endl; }
    void m4() override { std::cout << "B::m4" << std::endl; }
};

int main()
{
    A* a = new B();
    a->m1();
    a->m2();
    a->m3();
    a->m4();
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu