``` ini

BenchmarkDotNet=v0.13.2, OS=Windows 10 (10.0.19045.2251)
Intel Core i7-8550U CPU 1.80GHz (Kaby Lake R), 1 CPU, 8 logical and 4 physical cores
.NET SDK=7.0.100
  [Host]     : .NET 7.0.0 (7.0.22.51805), X64 RyuJIT AVX2
  DefaultJob : .NET 7.0.0 (7.0.22.51805), X64 RyuJIT AVX2


```
|                                                 Method |       Mean |     Error |    StdDev |     Median |
|------------------------------------------------------- |-----------:|----------:|----------:|-----------:|
|                                             NonVirtual |  0.0133 ns | 0.0035 ns | 0.0029 ns |  0.0140 ns |
|                                  NonVirtual_NoInlining |  0.5227 ns | 0.0063 ns | 0.0052 ns |  0.5221 ns |
|                                 Virtual_AVar_AInstance |  0.4862 ns | 0.0060 ns | 0.0050 ns |  0.4868 ns |
|                                 Virtual_AVar_CInstance |  0.4898 ns | 0.0062 ns | 0.0049 ns |  0.4897 ns |
|                                 Virtual_CVar_CInstance |  0.4981 ns | 0.0112 ns | 0.0093 ns |  0.4976 ns |
|                                 Virtual_DVar_DInstance |  0.0001 ns | 0.0004 ns | 0.0004 ns |  0.0000 ns |
|                                 Virtual_EVar_EInstance |  0.1754 ns | 0.0916 ns | 0.2524 ns |  0.0217 ns |
|            NonVirtual_TypeChoice_Switch_AVar_AInstance |  5.8670 ns | 0.0242 ns | 0.0202 ns |  5.8670 ns |
|            NonVirtual_TypeChoice_Switch_AVar_CInstance |  3.8930 ns | 0.0248 ns | 0.0232 ns |  3.8984 ns |
|           NonVirtual_TypeChoice_IfViaIs_AVar_AInstance |  6.5818 ns | 0.1625 ns | 0.1738 ns |  6.5114 ns |
|           NonVirtual_TypeChoice_IfViaIs_AVar_CInstance |  3.2049 ns | 0.0123 ns | 0.0102 ns |  3.2068 ns |
|      NonVirtual_TypeChoice_IfViaGetType_AVar_AInstance |  1.0498 ns | 0.0164 ns | 0.0153 ns |  1.0522 ns |
|      NonVirtual_TypeChoice_IfViaGetType_AVar_CInstance |  0.4945 ns | 0.0084 ns | 0.0070 ns |  0.4936 ns |
|      DirectImpl_TypeChoice_IfViaGetType_AVar_AInstance |  1.0351 ns | 0.0082 ns | 0.0064 ns |  1.0347 ns |
| DirectImpl_TypeChoice_IfViaGetType_aWithCVar_CInstance |  0.2765 ns | 0.0145 ns | 0.0128 ns |  0.2710 ns |
|        DirectImpl_TypeChoice_Dictionary_AVar_AInstance | 15.8711 ns | 0.2494 ns | 0.2449 ns | 15.8275 ns |
|        DirectImpl_TypeChoice_Dictionary_AVar_CInstance | 15.6141 ns | 0.0198 ns | 0.0165 ns | 15.6130 ns |
|              Constant_TypeChoice_Switch_AVar_AInstance |  5.6710 ns | 0.0421 ns | 0.0329 ns |  5.6553 ns |
|        Constant_TypeChoice_IfViaGetType_AVar_AInstance |  1.0216 ns | 0.0143 ns | 0.0134 ns |  1.0211 ns |
|          Constant_TypeChoice_Dictionary_AVar_AInstance | 15.0989 ns | 0.0532 ns | 0.0497 ns | 15.0908 ns |
|          Constant_TypeChoice_Dictionary_AVar_CInstance | 15.0973 ns | 0.0656 ns | 0.0582 ns | 15.0950 ns |
|                             NonVirtual_I1Var_AInstance |  1.0344 ns | 0.0144 ns | 0.0120 ns |  1.0325 ns |
|                             NonVirtual_I2Var_AInstance |  1.0441 ns | 0.0179 ns | 0.0158 ns |  1.0389 ns |
|                                Virtual_I1Var_AInstance |  1.0384 ns | 0.0086 ns | 0.0081 ns |  1.0384 ns |
|                                Virtual_I2Var_AInstance |  1.0440 ns | 0.0171 ns | 0.0160 ns |  1.0384 ns |
|                                Virtual_I1Var_CInstance |  1.0358 ns | 0.0167 ns | 0.0148 ns |  1.0330 ns |
